' wdConv.VBS V1.00 (C) yoshioka.teruo@nifty.com 2004-03-02
' wdConv.VBS converts character code with Microsoft Word.
' Usage: start wdConv.VBS [-f fromCode] [-t toCode] files...
' CharCode : JIS,SJIS,EUC,EBCDIC,UNICODE,UnicodeBigEndian,UTF-7,UTF-8

Option Explicit
Dim fso
Dim argv()
Dim arg
Dim argc
Dim oWord
Const wdOpenFormatEncodedText = 5
Const wdFormatEncodedText = 7
Dim oName
Dim oPath
Dim dirName
Dim baseName
Dim n
Dim fo
Dim fName
Dim iName
Dim i
Dim fCode
Dim tCode
fCode=msoEncodingJapaneseAutoDetect
tCode=msoEncodingJapaneseShiftJIS

Set fso=CreateObject("Scripting.FileSystemObject")

ReDim argv(Wscript.Arguments.Count)
For n=0 To Wscript.Arguments.Count-1
  arg=Wscript.Arguments(n)
  If LCase(arg)="-f" Then
    n=n+1
    arg=Wscript.Arguments(n)
    fCode=Code(arg)
  ElseIf LCase(arg)="-t" Then
    n=n+1
    arg=Wscript.Arguments(n)
    tCode=Code(arg)
  Else
    argv(argc)=arg
    argc=argc+1
  End If
Next
If argc=0 Then
  WScript.Echo "Usage: start wdConv.VBS [-f fromCode] [-t toCode] files..." & _
  vbCRLF & _
  "CharCode : JIS,SJIS,EUC,EBCDIC,UNICODE,UnicodeBigEndian,UTF-7,UTF-8"
  WScript.Quit
End If

For i=0 To argc-1
  arg=argv(i)
  Set fo=fso.GetFile(arg)
  dirName=fso.GetParentFolderName(fo.Path)
  iName=fo.Name
  baseName=fso.GetBaseName(iName)
  oName=fso.GetTempName
  oPath=fso.BuildPath(dirname,oName)
  Set oWord = CreateObject("Word.Application")
'  oWord.Visible=True
  call oWord.Documents.Open(fo.Path,,,,,,,,,wdOpenFormatEncodedText,fCode)
  oWord.ActiveDocument.SaveEncoding=tCode
  call oWord.ActiveDocument.SaveAs(oPath, wdFormatEncodedText)
  oWord.Quit
  For n=0 To 999
    fName=baseName & "." & Right("000" & n,3)
    Call Rename(fo,fName)
    If Err=0 Then
      Exit For
    ElseIf Err<>58 Then
      WScript.Echo Err.Number & " : " & Err.Description
      WScript.Quit
    End If
  Next
  WScript.Echo iName & " -> " & fName

  Set fo=fso.GetFile(oPath)
  Call Rename(fo,iName)
  If Err<>0  Then
    WScript.Echo Err.Number & ":" & Err.Description
    WScript.Quit
  End If
Next
WScript.Quit

Sub Rename(fo,newName)
  Dim k
  On Error Resume Next
  For k=0 To 99
    Err.Clear
    fo.Name=newName
    If Err.Number<>70 Then Exit For
    WScript.Sleep 100
  Next
End Sub

Const msoEncodingAutoDetect = 50001 '(&HC351)
Const msoEncodingJapaneseAutoDetect = 50932 '(&HC6F4)

Const msoEncodingJapaneseShiftJIS = 932 '(&H3A4)

Const msoEncodingEUCJapanese = 51932 '(&HCADC)

Const msoEncodingEBCDICJapaneseKatakanaExtended = 20290 '(&H4F42)
Const msoEncodingEBCDICJapaneseKatakanaExtendedAndJapanese = 50930 '(&HC6F2)
Const msoEncodingEBCDICJapaneseLatinExtendedAndJapanese = 50939 '(&HC6FB)

Const msoEncodingISO2022JPJISX02011989 = 50222 '(&HC42E)
Const msoEncodingISO2022JPJISX02021984 = 50221 '(&HC42D)
Const msoEncodingISO2022JPNoHalfwidthKatakana = 50220 '(&HC42C)

Const msoEncodingUnicodeBigEndian = 1201 '(&H4B1)
Const msoEncodingUnicodeLittleEndian = 1200 '(&H4B0)

Const msoEncodingUTF7 = 65000 '(&HFDE8)
Const msoEncodingUTF8 = 65001 '(&HFDE9)

Const msoEncodingISO88591Latin1 = 28591 '(&H6FAF)
Const msoEncodingUSASCII = 20127 '(&H4E9F)
Const msoEncodingWestern = 1252 '(&H4E4)

Function Code(arg)
  Select Case(LCase(arg))
    Case "jis"
      Code=msoEncodingISO2022JPJISX02011989
    Case "sjis"
      Code=msoEncodingJapaneseShiftJIS
    Case "euc"
      Code=msoEncodingEUCJapanese
    Case "ebcdic"
      Code=msoEncodingEBCDICJapaneseKatakanaExtendedAndJapanese
    Case "unicode"
      Code=msoEncodingUnicodeLittleEndian
    Case "unicodebigendian"
      Code=msoEncodingUnicodeBigEndian
    Case "utf-7"
      Code=msoEncodingUTF7
    Case "utf-8"
      Code=msoEncodingUTF8
    Case Else
      WScript.Echo "Invalid CharCode : " & arg & vbCRLF & _
      "Specify CharCode : JIS,SJIS,EUC,EBCDIC,UNICODE,UnicodeBigEndian,UTF-7,UTF-8"
      WScript.Quit
  End Select
End Function
